;---------------------------------------------
;FUNCTION - SHOW PLAYFIELD
;THIS FUNCTION WILL 18 SPRITES TO BUILD THE PLAYFIELD ON THE SCREEN.
;---------------------------------------------
SHOWPLAYFIELD
	;LOAD THE PLAYFIELD! (18 HARDWARE SPRITES IN TOTAL)
	;64X64 SIZED SPRITES FIRST, LAYOUT AS FOLLOWED
	;11112222--
	;11112222--
	;11112222--
	;11112222--
	;----------
	;----------
	;33334444--
	;33334444--
	;33334444--
	;33334444--
	
	LDA #2
	STA VAR_SPRITESTATUS	;STORE 2 IN VAR_SPRITESTATUS, USED TO TELL THE SETSPRITE FUNCTION TO LOAD A 64X64 SPRITES
	
	LoadPair z_hl,$0D00	;RamAddr & Colordepth (4bpp - 16 color) ;64X64 SPRITE 1
	LoadPair z_ix,$20	;Xpos ($10 = X = 16 pixels)
	LoadPair z_iy,$20	;Ypos ($10 = X = 16 pixels)
	LDA #100 			;LOAD THIS SPRITE AS HARDWARE SPRITE #100
	JSR SetSprite		;SET THE SPRITE ON SCREEN
	
	LoadPair z_hl,$0D00	;RamAddr & Colordepth (4bpp - 16 color)	;64X64 SPRITE 2
	LoadPair z_ix,$60	;Xpos ($10 = X = 16 pixels)
	LoadPair z_iy,$20	;Ypos ($10 = X = 16 pixels)
	LDA #101 			;LOAD THIS SPRITE AS HARDWARE SPRITE #101
	JSR SetSprite		;SET THE SPRITE ON SCREEN
	
	LoadPair z_hl,$0D00	;RamAddr & Colordepth (4bpp - 16 color)	;64X64 SPRITE 3
	LoadPair z_ix,$20	;Xpos ($10 = X = 16 pixels)
	LoadPair z_iy,$80	;Ypos ($10 = X = 16 pixels)
	LDA #109 			;LOAD THIS SPRITE AS HARDWARE SPRITE #109
	JSR SetSprite		;SET THE SPRITE ON SCREEN
	
	LoadPair z_hl,$0D00	;RamAddr & Colordepth (4bpp - 16 color)	;64X64 SPRITE 4
	LoadPair z_ix,$60	;Xpos ($10 = X = 16 pixels)
	LoadPair z_iy,$80	;Ypos ($10 = X = 16 pixels)
	LDA #110 			;LOAD THIS SPRITE AS HARDWARE SPRITE #110
	JSR SetSprite		;SET THE SPRITE ON SCREEN
	
	;32X32 SIZED SPRITES NEXT, LAYOUT AS FOLLOWED
	;--------11
	;--------11
	;--------22
	;--------22
	;3344556677
	;3344556677
	;--------88
	;--------88
	;99AABBCCDD
	;99AABBCCDD
	LDA #1
	STA VAR_SPRITESTATUS	;STORE 1 IN VAR_SPRITESTATUS, USED TO TELL THE SETSPRITE FUNCTION TO LOAD A 32X32 SPRITES
	
	LoadPair z_hl,$0CA0	;RamAddr & Colordepth (4bpp - 16 color)		;32X32 SPRITE 1
	LoadPair z_ix,$A0	;Xpos ($10 = X = 16 pixels)
	LoadPair z_iy,$20	;Ypos ($10 = X = 16 pixels)
	LDA #102 			;LOAD THIS SPRITE AS HARDWARE SPRITE #102
	JSR SetSprite		;SET THE SPRITE ON SCREEN
	
	LoadPair z_hl,$0CA0	;RamAddr & Colordepth (4bpp - 16 color)		;32X32 SPRITE 2
	LoadPair z_ix,$A0	;Xpos ($10 = X = 16 pixels)
	LoadPair z_iy,$40	;Ypos ($10 = X = 16 pixels)
	LDA #103 			;LOAD THIS SPRITE AS HARDWARE SPRITE #103
	JSR SetSprite		;SET THE SPRITE ON SCREEN
	
	LoadPair z_hl,$0C90	;RamAddr & Colordepth (4bpp - 16 color)		;32X32 SPRITE 3
	LoadPair z_ix,$20	;Xpos ($10 = X = 16 pixels)
	LoadPair z_iy,$60	;Ypos ($10 = X = 16 pixels)
	LDA #104 			;LOAD THIS SPRITE AS HARDWARE SPRITE #104
	JSR SetSprite		;SET THE SPRITE ON SCREEN
	
	LoadPair z_hl,$0C80	;RamAddr & Colordepth (4bpp - 16 color)		;32X32 SPRITE 4
	LoadPair z_ix,$40	;Xpos ($10 = X = 16 pixels)
	LoadPair z_iy,$60	;Ypos ($10 = X = 16 pixels)
	LDA #105 			;LOAD THIS SPRITE AS HARDWARE SPRITE #105
	JSR SetSprite		;SET THE SPRITE ON SCREEN
	
	LoadPair z_hl,$0C90	;RamAddr & Colordepth (4bpp - 16 color)		;32X32 SPRITE 5
	LoadPair z_ix,$60	;Xpos ($10 = X = 16 pixels)
	LoadPair z_iy,$60	;Ypos ($10 = X = 16 pixels)
	LDA #106 			;LOAD THIS SPRITE AS HARDWARE SPRITE #106
	JSR SetSprite		;SET THE SPRITE ON SCREEN
	
	LoadPair z_hl,$0C80	;RamAddr & Colordepth (4bpp - 16 color)		;32X32 SPRITE 6
	LoadPair z_ix,$80	;Xpos ($10 = X = 16 pixels)
	LoadPair z_iy,$60	;Ypos ($10 = X = 16 pixels)
	LDA #107 			;LOAD THIS SPRITE AS HARDWARE SPRITE #107
	JSR SetSprite		;SET THE SPRITE ON SCREEN
	
	LoadPair z_hl,$0CA0	;RamAddr & Colordepth (4bpp - 16 color)		;32X32 SPRITE 7
	LoadPair z_ix,$A0	;Xpos ($10 = X = 16 pixels)
	LoadPair z_iy,$60	;Ypos ($10 = X = 16 pixels)
	LDA #108 			;LOAD THIS SPRITE AS HARDWARE SPRITE #108
	JSR SetSprite		;SET THE SPRITE ON SCREEN
	
	LoadPair z_hl,$0CA0	;RamAddr & Colordepth (4bpp - 16 color)		;32X32 SPRITE 8
	LoadPair z_ix,$A0	;Xpos ($10 = X = 16 pixels)
	LoadPair z_iy,$80	;Ypos ($10 = X = 16 pixels)
	LDA #111 			;LOAD THIS SPRITE AS HARDWARE SPRITE #111
	JSR SetSprite		;SET THE SPRITE ON SCREEN
	
	LoadPair z_hl,$0CA0	;RamAddr & Colordepth (4bpp - 16 color)		;32X32 SPRITE 9
	LoadPair z_ix,$A0	;Xpos ($10 = X = 16 pixels)
	LoadPair z_iy,$A0	;Ypos ($10 = X = 16 pixels)
	LDA #112 			;LOAD THIS SPRITE AS HARDWARE SPRITE #112
	JSR SetSprite		;SET THE SPRITE ON SCREEN
	
	LoadPair z_hl,$0CB0	;RamAddr & Colordepth (4bpp - 16 color)		;32X32 SPRITE A
	LoadPair z_ix,$20	;Xpos ($10 = X = 16 pixels)
	LoadPair z_iy,$A0	;Ypos ($10 = X = 16 pixels)
	LDA #113 			;LOAD THIS SPRITE AS HARDWARE SPRITE #113
	JSR SetSprite		;SET THE SPRITE ON SCREEN
	
	LoadPair z_hl,$0CB0	;RamAddr & Colordepth (4bpp - 16 color)		;32X32 SPRITE B
	LoadPair z_ix,$40	;Xpos ($10 = X = 16 pixels)
	LoadPair z_iy,$A0	;Ypos ($10 = X = 16 pixels)
	LDA #114 			;LOAD THIS SPRITE AS HARDWARE SPRITE #114
	JSR SetSprite		;SET THE SPRITE ON SCREEN
	
	LoadPair z_hl,$0CB0	;RamAddr & Colordepth (4bpp - 16 color)		;32X32 SPRITE C
	LoadPair z_ix,$60	;Xpos ($10 = X = 16 pixels)
	LoadPair z_iy,$A0	;Ypos ($10 = X = 16 pixels)
	LDA #115 			;LOAD THIS SPRITE AS HARDWARE SPRITE #115
	JSR SetSprite		;SET THE SPRITE ON SCREEN
	
	LoadPair z_hl,$0CB0	;RamAddr & Colordepth (4bpp - 16 color)		;32X32 SPRITE D
	LoadPair z_ix,$80	;Xpos ($10 = X = 16 pixels)
	LoadPair z_iy,$A0	;Ypos ($10 = X = 16 pixels)
	LDA #116 			;LOAD THIS SPRITE AS HARDWARE SPRITE #116
	JSR SetSprite		;SET THE SPRITE ON SCREEN
	
	;THIS SPRITE LOADS OVER SPRITE 9'S POSITION. IT'S TO CLOSE THE LINES ON THE BOTTOM OF THE SPRITE
	LoadPair z_hl,$0CB0	;RamAddr & Colordepth (4bpp - 16 color)		;32X32 SPRITE e
	LoadPair z_ix,$A0	;Xpos ($10 = X = 16 pixels)
	LoadPair z_iy,$A0	;Ypos ($10 = X = 16 pixels)
	LDA #117 			;LOAD THIS SPRITE AS HARDWARE SPRITE #117
	JSR SetSprite		;SET THE SPRITE ON SCREEN

	RTS					;RETURN BACK TO THE PREVIOUS CODE

;---------------------------------------------
;FUNCTION - INITIALIZE PHASE 0
;THIS FUNCTION INITIALIZES THE SPRITES AND VARIABLES FOR PHASE 0 OF THE GAME
;---------------------------------------------
INITPHASE0VARS
	;LETS START WITH CLEARING THE WHOLE SPRITE ARRAY DATA FIRST
	LDA #SPRITEARRAYH		;LOAD THE SPRITE DATA ARRAY HIGH BYTE IN A
	STA ZPADDR+1			;STORE IN ZPADDR+1 (HIGH BYTE)
	STZ ZPADDR				;STORE LOW BYTE IN ZPADDR (0)
	LDY #0					;LOAD 0 IN Y, LOOP COUNTER
	LDX #0					;LOAD 0 IN X, USED AS COUNTING THE PROPERTY PER SPRITE (0-2)
	LDA #0					;LOAD 0 IN A, THIS IS THE VALUE TO SET (0)

INITPHASE0LOOP1
	STA (ZPADDR),Y			;STORE 0 IN MEMORY ADDRESS ZPADDR ($0400) OFFSET BY Y
	
	CPX #1					;CHECK IF THIS IS THE 2ND PROPERTY OF THE SPRITE (XY POSITION)
	BNE INITPHASE0LOOP1A	;IF IT'S NOT, SKIP OVER THE NEXT PART
	LDA #$FF 				;LOAD FF IN A
	STA (ZPADDR),Y			;REPLACE THE PROPERTY WITH FF, SO THE X AND Y POSITION START AS FF
	LDA #0					;RESET A WITH 0
INITPHASE0LOOP1A
	INX						;INCREMENT TO THE NEXT PROPERTY OF THE SPRITE
	CPX #3					;IF THE PROPERTY COUNTER IS NOW AT 3? 
	BNE INITPHASE0LOOP1B	;IF NOT, SKIP THE NEXT CODE
	LDX #0					;IF IT IS 3, IT NEED TO ROLL BACK TO 0 (SINCE IT SHOULD BE 0-2)
	
INITPHASE0LOOP1B			
	INY
	CPY #248				;WE NEED TO WIPE 247 BYTES (82 SPRITES * 3). CHECK IF WE HAVE ALREADY WIPED THAT MANY
	BNE	INITPHASE0LOOP1		;IF NOT, CONTINUE TO WIPE THE NEXT ONE
	;OTHERWISE WE'RE DONE WIPING THE SPRITE DATA ARRAY
	
	;NOW WE NEED TO SET THE GAME PIECE TYPE FOR THE PLAYER CURSOR.
	LDA #80					;LOAD 80 IN A (WHICH IS THE SPRITE NUMBER FOR THE PLAYER CURSOR)
	LDX #13					;LOAD 13 IN X FOR THE PIECE TYPE. WE USE PIECE TYPE 13 SO THE VERA MEMORY ADDRES WILL BE CALCULATED CORRECTLY	
	JSR SETPIECETYPE		;SET THE PIECE TYPE
	LDX #0
	LDY #6
	JSR MOVEPIECE			;MOVE THE CURSOR TO X=0,Y=6, BUT DON'T SHOW IT YET
	
	;NOW WE NEED TO SET THE GAME PIECE TYPE FOR THE PREVIOUSLY SELECTED PLAYER CURSOR
	LDA #81					;LOAD 81 IN A (WHICH IS THE SPRITE NUMBER FOR THE PLAYER PREVOUSLY SELECTED CURSOR)
	LDX #14					;LOAD 14 IN X FOR THE PIECE TYPE. WE USE PIECE TYPE 14 SO THE VERA MEMORY ADDRES WILL BE CALCULATED CORRECTLY	
	JSR SETPIECETYPE		;SET THE PIECE TYPE
	LDX #0
	LDY #6
	JSR MOVEPIECE			;MOVE THE CURSOR TO X=0,Y=6, BUT DON'T SHOW IT YET
	
	;SET THE FIRST TURN TO THE PLAYERS
	STZ VAR_TURN			;SET VAR_TURN TO 0 (PLAYER'S TURN)
	STZ VAR_ATTACK			;SET THE ATTACK VARIABLE TO 0, SO THE COMPUTER'S PIECES FRONT SIDE ARE NOT SHOWN, ONLY THE BACKSIDE
	STZ VAR_TURNS			;RESET THE AMOUNT OF TURNS PLAYED TO 0
	
INITPHASE0VARSY
	RTS						;RETURN TO PREVIOUS CODE
